#ifndef DYNBH_H
#define DYNBH_H

#define MAP_UPLINK_PATH 	"/var/run/multiap/multiap.backhaul"

#ifdef PERSIST_CONTROLLER
enum cntlr_discovery_mode {
	DYNAMIC_CNTLR_MODE_AUTO,
	DYNAMIC_CNTLR_MODE_DISABLED,
	DYNAMIC_CNTLR_MODE_CONTROLLER,
};
#endif


struct ethport {
	bool connected;
	bool loop;
	bool active_uplink;
	char ifname[16];
	uint8_t backhaul_mac[6];
	uint8_t backhaul_device_id[6];
	uint8_t num_mid;
	uint16_t mid[32];
	atimer_t bridge_add;
	atimer_t send_apconf;
	int retries;
	atimer_t send_dhcp_discovery;
	int dhcp_retries;
	struct list_head list;
	struct dynbh_ctx *ctx;
};

struct dynbh_ctx {
	uint8_t alid[6];
	char alidstr[16]; /* 6 octet macaddr without separators */
	char al_bridge[16];
	uint16_t cmdu_mask;
	struct ubus_context *ctx;
	uint32_t oid;
	uint32_t map_oid;
	void *subscriber;
	struct ubus_event_handler evh;
	int queued_searches;
	//struct list_head searches; /* currently active autoconfig search queries */
	//struct list_head loops;
	struct list_head ethportlist; /*  */
	atimer_t heartbeat;
	struct ubus_object obj;
#ifdef PERSIST_CONTROLLER
	enum cntlr_discovery_mode discovery_mode;
#endif

};

void delif(struct ethport *ap);
void addif(struct ethport *ap);


struct ethport *ethport_by_ifname(struct dynbh_ctx *p,
		const char *ifname);
struct ethport *loop_by_ifname(struct dynbh_ctx *p, char *ifname);
struct ethport *ethport_by_mid(struct dynbh_ctx *p, uint16_t mid);


void free_ethport_search(struct ethport *ap);

#endif
